%define datestamp 20060203

Summary: libstdc++.so.7 preview
Name: libstdc++so7
Version: 4.2.0
Release: 0.3.%{datestamp}.2
License: GPL
Group: System Environment/Libraries
Source0: gcc_stub-4.1-20060118.tar.bz2
Source1: libstdc++-v3-so7-%{datestamp}.tar.bz2
URL: http://gcc.gnu.org
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: binutils >= 2.16.91.0.5-1, gcc >= 4.1.0
BuildRequires: dejagnu, texinfo
AutoReq: true

%define _gnu %{nil}

%description
The libstdc++so7 package contains a preview of the GNU Standard C++
Library from libstdcxx_so_7-branch branch.  It is considered
experimental, and may in fact be completely unreliable. Don't rely on
its ABI, or its API as it might change at any time. To use, invoke
'g++-libstdc++so_7' instead of 'g++'.

%package devel
Summary: Header files and static libraries for libstdc++.so.7 preview
Group: Development/Libraries
Requires: libstdc++so7 = %{version}-%{release}
Requires: gcc-c++ = 4.1.0, libstdc++-devel = 4.1.0
# Need binutils that support .weakref
Requires: binutils >= 2.16.91.0.5-1
Autoreq: true

%description devel
The libstdc++so7-devel package contains header files and static
libraries for preview of the GNU Standard C++ Library from
libstdcxx_so_7-branch branch.  It is considered experimental, and may
in fact be completely unreliable. Don't rely on its ABI, or API as it
might change any time.

%prep
%setup -q -n gcc_stub-4.1 -a 1 

%build
mkdir obj
cd obj
CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" ../configure \
  --enable-languages=c,c++ --disable-multilib %{_target_platform}
mkdir gcc
cp -a ../copy_to_gcc/* gcc/
gccdir=`cd $(gcc $RPM_OPT_FLAGS -print-file-name=include)/..; pwd`
for l in `cd $gccdir; find . -name libgcc.a`; do
  mkdir -p gcc/`dirname $l`
  pwd
  ln -sf $gccdir/$l gcc/`dirname $l`/
done
echo %{datestamp} > gcc/DATESTAMP

make %{?_smp_mflags} all-target-libstdc++-v3

# run the tests.
#make %{?_smp_mflags} -k check-target-libstdc++-v3 || :

echo ====================TESTING=========================
( ../contrib/test_summary || : ) 2>&1 | sed -n '/^cat.*EOF/,/^EOF/{/^cat.*EOF/d;/^EOF/d;/^LAST_UPDATED:/d;p;}'
echo ====================TESTING END=====================

%install
rm -fr $RPM_BUILD_ROOT

cd obj

make prefix=$RPM_BUILD_ROOT%{_prefix} mandir=$RPM_BUILD_ROOT%{_mandir} \
  infodir=$RPM_BUILD_ROOT%{_infodir} install-target-libstdc++-v3

# library binaries
libversion=4.2.0-%{datestamp}
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la \
  $RPM_BUILD_ROOT%{_libdir}/libstdc++.so{.7,}
mv $RPM_BUILD_ROOT%{_libdir}/libstdc++.so.7.0.0 \
  $RPM_BUILD_ROOT%{_libdir}/libstdc++-%{datestamp}.so.7.0.0
ln -sf libstdc++-%{datestamp}.so.7.0.0 \
  $RPM_BUILD_ROOT%{_libdir}/libstdc++-%{datestamp}.so.7

# links for shared library
mkdir -p $RPM_BUILD_ROOT%{_prefix}/lib/gcc/%{_target_platform}/$libversion
mv $RPM_BUILD_ROOT%{_libdir}/*.a \
  $RPM_BUILD_ROOT%{_prefix}/lib/gcc/%{_target_platform}/$libversion/
pushd $RPM_BUILD_ROOT%{_prefix}/lib/gcc/%{_target_platform}/$libversion/
if [ "%{_lib}" = lib64 ]; then
  ln -sf ../../../../lib64/libstdc++*.so.7 libstdc++.so
else
  ln -sf ../../../libstdc++*.so.7 libstdc++.so
fi
popd

# include files
includeprefix=include/c++/$libversion
mkdir -p $RPM_BUILD_ROOT%{_prefix}/$includeprefix
mv $RPM_BUILD_ROOT%{_includedir}/c++/4.1.0/* $RPM_BUILD_ROOT%{_prefix}/$includeprefix

# As this is just a preview package and also we don't have a strong dependency
# on exact gcc-c++ NVR, nuke precompiled headers
find $RPM_BUILD_ROOT%{_prefix}/$includeprefix -name stdc++.h.gch | xargs rm -rf

# make driver program
mkdir -p $RPM_BUILD_ROOT%{_bindir}
cat > $RPM_BUILD_ROOT%{_bindir}/g++-libstdc++-so_7 <<\EOF
#!/bin/sh
EOF
echo "datestamp=%{datestamp}" >> $RPM_BUILD_ROOT%{_bindir}/g++-libstdc++-so_7
cat >> $RPM_BUILD_ROOT%{_bindir}/g++-libstdc++-so_7 <<\EOF
libversion=4.2.0-%{datestamp}
includepath=include/c++/$libversion
%ifarch %{ix86} x86_64 ppc ppc64 s390 s390x sparc sparc64
M=`echo "$*" | LC_ALL=C sed -n 's/^.*[[:blank:]]\(-m[63][421]\)\([[:blank:]].*$\|$\)/\1/p'`
D=`/usr/bin/gcc -print-multi-os-directory $M`
%endif
%ifarch %{ix86} x86_64
case "$D" in
  ../lib64) T=x86_64-%{_vendor}-%{_os};;
  *) T=i386-%{_vendor}-%{_os};;
esac
%endif
%ifarch ppc ppc64
case "$D" in
  ../lib64) T=ppc64-%{_vendor}-%{_os};;
  *) T=ppc-%{_vendor}-%{_os};;
esac
%endif
%ifarch s390 s390x
case "$D" in
  ../lib64) T=s390x-%{_vendor}-%{_os};;
  *) T=s390-%{_vendor}-%{_os};;
esac
%endif
%ifarch sparc sparc64
case "$D" in
  ../lib64) T=sparc64-%{_vendor}-%{_os};;
  *) T=sparc-%{_vendor}-%{_os};;
esac
%endif
%ifnarch %{ix86} x86_64 ppc ppc64 s390 s390x sparc sparc64
T=%{_target_platform}
%endif
exec /usr/bin/g++ \
     -D__FLT_HAS_DENORM__=__FLT_DENORM_MIN__ \
     -D__DBL_HAS_DENORM__=__DBL_DENORM_MIN__ \
     -D__LDBL_HAS_DENORM__=__LDBL_DENORM_MIN__ \
     "$@" -isystem %{_prefix}/$includepath \
     -isystem %{_prefix}/$includepath/$T \
     -isystem %{_prefix}/$includepath/backwards \
     -L %{_prefix}/lib/gcc/$T/$libversion/
EOF
chmod +x $RPM_BUILD_ROOT%{_bindir}/g++-libstdc++-so_7

rm -rf $RPM_BUILD_ROOT%{_datadir}

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%{_prefix}/%{_lib}/libstdc++*.so.7*

%files devel
%{_prefix}/bin/g++-libstdc++-so_7
%dir %{_prefix}/lib/gcc
%{_prefix}/lib/gcc/%{_target_platform}/4.2.0-*
%{_prefix}/include/c++/4.2.0-*

%changelog
* Fri Mar 10 2006 Bill Nottingham <notting@redhat.com> - 4.2.0-0.3.20060203.2
- rebuild for ppc TLS issue (#184446)

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 4.2.0-0.3.20060203.1
- bump again for double-long bug on ppc(64)

* Fri Feb 03 2006 Benjamin Kosnik <bkoz@redhat.com> 4.2.0-0.3
- Fixup datestamp issues.
- Use datestamp, or something close, as part of the versioned namespace name.
- Rebase libstdc++ sources.

* Sat Jan 28 2006 Benjamin Kosnik <bkoz@redhat.com> 4.2.0-0.2
- Changes to script, directory layouts.
- Rebase libstdc++ sources.

* Wed Jan 18 2006 Jakub Jelinek <jakub@redhat.com> 4.2.0-0.1
- new package
